/*
 * freee人事労務 API
 *
 * freee人事労務のAPI仕様です。  ## 認証について  OAuth2.0を利用します。詳細は[ドキュメントの認証](https://developer.freee.co.jp/docs)パートを参照してください。  ## エンドポイント  https://api.freee.co.jp/hr  ## 後方互換性ありの変更  freeeでは、APIを改善していくために以下のような変更は後方互換性ありとして通知なく変更を入れることがあります。アプリケーション実装者は以下を踏まえて開発を行ってください。  - 新しいAPIリソース・エンドポイントの追加 - 既存のAPIに対して必須ではない新しいリクエストパラメータの追加 - 既存のAPIレスポンスに対する新しいプロパティの追加 - 既存のAPIレスポンスに対するプロパティの順番の入れ変え - keyとなっているidやcodeの長さの変更（長くする）  ## エラーレスポンス  APIリクエストでエラーが発生した場合は、エラー原因に応じたステータスコードおよびメッセージを返します。  |ステータスコード|原因| |---|---| |400|リクエストパラメータが不正| |401|アクセストークンが無効| |403|アクセス権限がない| |404|リソースが存在しない| |429|リクエスト回数制限を越えた| |503|システム内で予期しないエラーが発生|  メッセージボディ内の `messages` にはエラー内容を説明する文字列が入ります。  ``` {     \"status_code\": 400,     \"errors\": [         {             \"type\": \"bad_request\",             \"messages\": [                 \"リクエストの形式が不正です。\"             ]         }     ] } ```  ## API使用制限  APIリクエストは1時間で5000回を上限としています。API使用ステータスはレスポンスヘッダに付与されます。  ``` X-Ratelimit-Limit:5000 X-Ratelimit-Remaining:4998 X-Ratelimit-Reset:2018-01-01T12:00:00.000000Z ```  各ヘッダの意味は次のとおりです。  |ヘッダ名|説明| |---|---| |X-Ratelimit-Limit|使用回数の上限| |X-Ratelimit-Remaining|残り使用回数| |X-Ratelimit-Reset|使用回数がリセットされる時刻|  上記に加え、freeeは一定期間に過度のアクセスを検知した場合、APIアクセスをコントロールする場合があります。 その際のhttp status codeは403となります。制限がかかってから10分程度が過ぎると再度使用することができるようになります。  
 *
 * The version of the OpenAPI document: v2022-02-01
 * 
 * Generated by: https://openapi-generator.tech
 */




#[derive(Clone, Debug, PartialEq, Default, Serialize, Deserialize)]
pub struct ApiV1EmployeesWelfarePensionInsuranceRuleSerializer {
    #[serde(rename = "id", skip_serializing_if = "Option::is_none")]
    pub id: Option<i32>,
    /// 賞与計算時の子ども・子育て拠出金の計算方法
    #[serde(rename = "child_allowance_contribution_bonus_calc_type", skip_serializing_if = "Option::is_none")]
    pub child_allowance_contribution_bonus_calc_type: Option<ChildAllowanceContributionBonusCalcType>,
    /// 給与計算時の子ども・子育て拠出金の計算方法
    #[serde(rename = "child_allowance_contribution_salary_calc_type", skip_serializing_if = "Option::is_none")]
    pub child_allowance_contribution_salary_calc_type: Option<ChildAllowanceContributionSalaryCalcType>,
    /// 事業所ID
    #[serde(rename = "company_id", skip_serializing_if = "Option::is_none")]
    pub company_id: Option<i32>,
    /// 従業員ID
    #[serde(rename = "employee_id", skip_serializing_if = "Option::is_none")]
    pub employee_id: Option<i32>,
    /// 厚生年金保険に加入しているかどうか
    #[serde(rename = "entried", skip_serializing_if = "Option::is_none")]
    pub entried: Option<bool>,
    /// 賞与計算時の子ども・子育て拠出金の直接指定金額
    #[serde(rename = "manual_child_allowance_contribution_amount_bonus", skip_serializing_if = "Option::is_none")]
    pub manual_child_allowance_contribution_amount_bonus: Option<f32>,
    /// 給与計算時の子ども・子育て拠出金の直接指定金額
    #[serde(rename = "manual_child_allowance_contribution_amount_salary", skip_serializing_if = "Option::is_none")]
    pub manual_child_allowance_contribution_amount_salary: Option<f32>,
    /// 賞与計算時の厚生年金保険料の直接指定金額（会社負担分）
    #[serde(rename = "manual_welfare_pension_insurance_amount_of_company_bonus", skip_serializing_if = "Option::is_none")]
    pub manual_welfare_pension_insurance_amount_of_company_bonus: Option<f32>,
    /// 給与計算時の厚生年金保険料の直接指定金額（会社負担分）
    #[serde(rename = "manual_welfare_pension_insurance_amount_of_company_salary", skip_serializing_if = "Option::is_none")]
    pub manual_welfare_pension_insurance_amount_of_company_salary: Option<f32>,
    /// 賞与計算時の厚生年金保険料の直接指定金額（従業員負担分）
    #[serde(rename = "manual_welfare_pension_insurance_amount_of_employee_bonus", skip_serializing_if = "Option::is_none")]
    pub manual_welfare_pension_insurance_amount_of_employee_bonus: Option<i32>,
    /// 給与計算時の厚生年金保険料の直接指定金額（従業員負担分）
    #[serde(rename = "manual_welfare_pension_insurance_amount_of_employee_salary", skip_serializing_if = "Option::is_none")]
    pub manual_welfare_pension_insurance_amount_of_employee_salary: Option<i32>,
    /// 厚生年金保険の被保険者整理番号
    #[serde(rename = "reference_num", skip_serializing_if = "Option::is_none")]
    pub reference_num: Option<String>,
    /// 標準報酬月額
    #[serde(rename = "standard_monthly_remuneration", skip_serializing_if = "Option::is_none")]
    pub standard_monthly_remuneration: Option<i32>,
    /// 賞与計算時の厚生年金保険料の計算方法
    #[serde(rename = "welfare_pension_insurance_bonus_calc_type", skip_serializing_if = "Option::is_none")]
    pub welfare_pension_insurance_bonus_calc_type: Option<WelfarePensionInsuranceBonusCalcType>,
    /// 給与計算時の厚生年金保険料の計算方法
    #[serde(rename = "welfare_pension_insurance_salary_calc_type", skip_serializing_if = "Option::is_none")]
    pub welfare_pension_insurance_salary_calc_type: Option<WelfarePensionInsuranceSalaryCalcType>,
}

impl ApiV1EmployeesWelfarePensionInsuranceRuleSerializer {
    pub fn new() -> ApiV1EmployeesWelfarePensionInsuranceRuleSerializer {
        ApiV1EmployeesWelfarePensionInsuranceRuleSerializer {
            id: None,
            child_allowance_contribution_bonus_calc_type: None,
            child_allowance_contribution_salary_calc_type: None,
            company_id: None,
            employee_id: None,
            entried: None,
            manual_child_allowance_contribution_amount_bonus: None,
            manual_child_allowance_contribution_amount_salary: None,
            manual_welfare_pension_insurance_amount_of_company_bonus: None,
            manual_welfare_pension_insurance_amount_of_company_salary: None,
            manual_welfare_pension_insurance_amount_of_employee_bonus: None,
            manual_welfare_pension_insurance_amount_of_employee_salary: None,
            reference_num: None,
            standard_monthly_remuneration: None,
            welfare_pension_insurance_bonus_calc_type: None,
            welfare_pension_insurance_salary_calc_type: None,
        }
    }
}

/// 賞与計算時の子ども・子育て拠出金の計算方法
#[derive(Clone, Copy, Debug, Eq, PartialEq, Ord, PartialOrd, Hash, Serialize, Deserialize)]
pub enum ChildAllowanceContributionBonusCalcType {
    #[serde(rename = "auto")]
    Auto,
    #[serde(rename = "manual")]
    Manual,
}

impl Default for ChildAllowanceContributionBonusCalcType {
    fn default() -> ChildAllowanceContributionBonusCalcType {
        Self::Auto
    }
}
/// 給与計算時の子ども・子育て拠出金の計算方法
#[derive(Clone, Copy, Debug, Eq, PartialEq, Ord, PartialOrd, Hash, Serialize, Deserialize)]
pub enum ChildAllowanceContributionSalaryCalcType {
    #[serde(rename = "auto")]
    Auto,
    #[serde(rename = "manual")]
    Manual,
}

impl Default for ChildAllowanceContributionSalaryCalcType {
    fn default() -> ChildAllowanceContributionSalaryCalcType {
        Self::Auto
    }
}
/// 賞与計算時の厚生年金保険料の計算方法
#[derive(Clone, Copy, Debug, Eq, PartialEq, Ord, PartialOrd, Hash, Serialize, Deserialize)]
pub enum WelfarePensionInsuranceBonusCalcType {
    #[serde(rename = "auto")]
    Auto,
    #[serde(rename = "manual")]
    Manual,
}

impl Default for WelfarePensionInsuranceBonusCalcType {
    fn default() -> WelfarePensionInsuranceBonusCalcType {
        Self::Auto
    }
}
/// 給与計算時の厚生年金保険料の計算方法
#[derive(Clone, Copy, Debug, Eq, PartialEq, Ord, PartialOrd, Hash, Serialize, Deserialize)]
pub enum WelfarePensionInsuranceSalaryCalcType {
    #[serde(rename = "auto")]
    Auto,
    #[serde(rename = "manual")]
    Manual,
}

impl Default for WelfarePensionInsuranceSalaryCalcType {
    fn default() -> WelfarePensionInsuranceSalaryCalcType {
        Self::Auto
    }
}

